using System.Collections;
using System.Collections.Generic;
using DefaultNamespace;
using Unity.Mathematics;
using UnityEngine;

namespace DefaultNamespace
{ 
    public class EnemyVariant4 : Enemy
    {
        public override void InternalStart()
        {
            this.Firecool = 1f;
            this.hp = 10;
        }
        
        public override void Shoot()
        {
        }

        public override void InternalUpdate()
        {
            if (Firecool < 1f)
            {
                Firecool += Time.deltaTime;
            }

            if (Firecool >= 1f)
            {
                Vector3 p1 = this.transform.position;
                p1 -= new Vector3(0.55f, 0.2f, 0);
                Instantiate(this.laserenemy, p1, Quaternion.identity);
                Firecool = 0;
            }
        }
    }
}