using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.InputSystem;
using UnityEngine.UI;
using TMPro;
using UnityEngine.SceneManagement;

public class Movement : MonoBehaviour
{
    private PlayerController input = null;
    public GameObject p;
    public Projectile laser;
    public Projectile laser1;
    public GameObject text;
    private Vector2 moveVector = Vector2.zero;
    private InputAction move;
    private InputAction fire;
    private InputAction fire1;
    public Image fire1img;
    private InputAction fire2;
    private InputAction fire3;
    private InputAction fire4;
    private InputAction god;
    private Rigidbody2D rb = null;
    private float moveSpeed = 4f;
    private bool shooting = false;
    private float firecool = 0.2f;
    private float firecool1 = 3f;
    public ParticleSystem expl;


    private void Awake() {
    input = new PlayerController();
    rb = GetComponent<Rigidbody2D>();
   }
    private void Start()
    {
       fire1img.color = new Color(1f, 1f, 1f, 0.55f); 
    }
   private void OnEnable() {
    move = input.Player.Movement;
    fire = input.Player.Fire;
    fire1 = input.Player.Fire2;
    god = input.Player.God;
    move.Enable();
    fire.Enable();
    fire1.Enable();
    god.Enable();
    fire.performed += Fire;
    fire1.performed += Fire1;
    god.performed += God;
   }
    private void OnDisable() {
        move.Disable();
        fire.Disable();
        fire1.Disable();
        god.Disable();
    }

    private void Update() {
        moveVector = move.ReadValue<Vector2>();
        if (firecool < 0.2f)
            firecool += Time.deltaTime;
        if (firecool1 < 3f)
            firecool1 += Time.deltaTime;
        if (shooting && firecool >= 0.2f)
        {
            Vector3 h = this.transform.position;
            h += new Vector3 (0.55f, 0, 0);
            Instantiate(this.laser, h, Quaternion.identity);
            firecool = 0f;
        }
        fire1img.fillAmount = firecool1/3;
        if (firecool1 >= 3f)
            fire1img.color = new Color(1f, 1f, 1f, 0.55f);
        else 
            fire1img.color = new Color(1f, 1f, 1f, 0.3f); 
        
    }

    private void FixedUpdate() {
        rb.velocity = moveVector * moveSpeed;
    }
    
    void OnTriggerEnter2D(Collider2D other) {
        if (other.gameObject.CompareTag("EnemyLaser") && this.CompareTag("Player"))
        {
            Instantiate(this.expl, this.transform.position, Quaternion.identity);
            Destroy(this.gameObject);
        }
    }
    private void Fire(InputAction.CallbackContext context) {
       shooting = !shooting;
    }

    private void Fire1(InputAction.CallbackContext context) {
       if (firecool1 >= 3f)
        {
          Vector3 h = this.transform.position;
          Vector3 h1 = this.transform.position;
          Vector3 h2 = this.transform.position;
            h += new Vector3 (0.55f, 0.2f, 0);
            h1 += new Vector3 (0.55f, -0.2f, 0);
            h2 += new Vector3 (0.85f, 0, 0);
            Instantiate(this.laser1, h, Quaternion.identity); 
            Instantiate(this.laser1, h1, Quaternion.identity); 
            Instantiate(this.laser1, h2, Quaternion.identity);
            firecool1 = 0;
        }
    }

    private void God(InputAction.CallbackContext context) {
        bool isActive = text.activeSelf;
        text.SetActive(!isActive);
        if (!isActive)
            p.tag = "God";
        else
            p.tag = "Player";
    }
}
