using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public abstract class Projectile : MonoBehaviour
{
    protected Vector3 direction;
    protected float speed;
    protected int dmg;
    void Start()
    {
        GameObject border = GameObject.FindGameObjectWithTag("Limit");
        Physics2D.IgnoreCollision(border.GetComponent<Collider2D>(), GetComponent<Collider2D>());
    }

    // Update is called once per frame
    void Update()
    {
        this.transform.position += this.direction * this.speed * Time.deltaTime;
        // Debug.Log(transform.position);
    }
    private void OnTriggerEnter2D(Collider2D other) {
        if (other.gameObject.CompareTag("Border") || other.gameObject.CompareTag("Enemy"))
        {
            // Debug.Log(other.gameObject.tag);
            Destroy(this.gameObject);
        }
    }

    public int GetDmg() {
        return this.dmg;
    }
}
