using System;
using System.Collections;
using System.Collections.Generic;
using TMPro;
using UnityEngine;

public class CounterFader : MonoBehaviour
{
    // Start is called before the first frame update

    private float _counter;
    private TextMeshPro _text;
    private float _grad;
    private float _step;
    
    void Start()
    {
        _counter = 2;
        _grad = 255;
        _step = _grad / _counter;
        _text = this.gameObject.GetComponent<TextMeshPro>(); 
        _text.transform.position -= new Vector3(0, 1f, 0);
    }

    // Update is called once per frame
    void Update()
    {
        _counter -= Time.deltaTime;
        if (_counter <= 0)
        {
            Destroy(this.gameObject);
        }
        else
        {
            _text.fontSize -= Time.deltaTime * 2;
            _text.transform.position += new Vector3(0, Time.deltaTime, 0);
            _grad -= (_step * Time.deltaTime);
            var help = (byte) Math.Floor(_grad);
            _text.faceColor = new Color32(255, 255, 255, help);
        }
    }
}
