using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.SceneManagement;
using UnityEngine.UI;

public class SceneLoader : MonoBehaviour
{
    public Button GameStarter;
    private Scene currentScene;
    public Movement player;
    // Start is called before the first frame update
    void Start()
    {
        GameStarter.onClick.AddListener(StartGame);
    }
    public void StartGame()
    {
        SceneManager.LoadScene(1);
    }
    
    IEnumerator WaitForSceneLoad()
    {
        yield return new WaitForSeconds(3f);
        SceneManager.LoadScene(0);
    }
    // Update is called once per frame
    void Update()
    {
        if (player == null && currentScene.name == "MainScene")
        {
            StartCoroutine(WaitForSceneLoad());
        }
        currentScene = SceneManager.GetActiveScene();
    }
}
